%% Author: rekby
%% Created: 27.04.2012
%% Description: TODO: Add description to t
-module(t).

%%
%% Include files
%%
-compile(export_all).
-define(THREADS_COUNT, 10).
-define(WARNUP, 5000).
-define(WORK_TIME, 12000).
-define(COUNTER_SECONDS, 5).
-define(COUNTER_TIME, ?COUNTER_SECONDS * 1000).

%%
%% Exported Functions
%%
-export([]).

%%
%% API Functions
%%
data_generator(F)->
	F({n(), now()}),
	%{n(), now()},
	%F({aaa,sss,ddd}),
	data_generator(F).

data_thread(F, Time)->
	spawn(fun()->timer:kill_after(Time), data_generator(F) end).

start_data_threads(_F, _Time, 0)->
	ok;
start_data_threads(F, Time, Count)->
	data_thread(F, Time),
	start_data_threads(F, Time, Count-1).

t()->
%	{ok, Pid} = e:start_link(),
%	start_data_threads(fun(Data)->e:put(Data) end, ?WORK_TIME, ?THREADS_COUNT),
	{ok, Pid} = m:start_link(),
	start_data_threads(fun(Data)->e:put(Data) end, ?WORK_TIME, ?THREADS_COUNT),
	spawn(fun()->timer:sleep(?WORK_TIME + ?WORK_TIME div 10), erlang:exit(Pid, exit), io:format("stop~n", []) end),
	io:format("start~n", []),
	timer:sleep(?WARNUP),
	OldCount = e:get_count(),
	io:format("~p~n", [OldCount div 5]),
	timer:sleep(?COUNTER_TIME),
	NewCount = e:get_count(),
	NormalCount = (NewCount - OldCount) div ?COUNTER_SECONDS,
	io:format("~p~n", [NormalCount]).
	
tm()->
	{ok, Pid} = m:start_link(),
	start_data_threads(fun(Data)->m:put(Data) end, ?WORK_TIME, ?THREADS_COUNT),
	spawn(fun()->timer:sleep(?WORK_TIME + ?WORK_TIME div 10), erlang:exit(Pid, exit), io:format("stop~n", []) end),
	io:format("start~n", []),
	timer:sleep(?WARNUP),
	OldCount = m:get_count(),
	io:format("~p~n", [OldCount div 5]),
	timer:sleep(?COUNTER_TIME),
	NewCount = m:get_count(),
	NormalCount = (NewCount - OldCount) div ?COUNTER_SECONDS,
	io:format("~p~n", [NormalCount]).
	
%%
%% Local Functions
%%
n()->
	{_M, Sec, _Mi} = now(),
	Sec.
n2()->
	{MegaSec, Sec, _Millisec} = now(),
	MegaSec*1000000 + Sec.